import * as _feathersjs_feathers from '@feathersjs/feathers';
import { Params, HookContext, Id } from '@feathersjs/feathers';
import { Promisable } from 'type-fest';

type Change<T = any> = {
    before: T;
    item: T;
};
type ChangesById<T = any> = {
    [key: string]: Change<T>;
    [key: number]: Change<T>;
};
type ManipulateParams = (params: Params, context: HookContext) => (Promisable<Params>);
interface HookChangesByIdOptions {
    skipHooks: boolean;
    params?: ManipulateParams;
    deleteParams?: string[];
    name?: string | string[];
    /** @default false */
    fetchBefore?: boolean;
}
interface ChangesByIdParams extends Params {
    changesById: any;
}
declare module "@feathersjs/feathers" {
    interface Params {
        paginate?: any;
        changesById?: any;
    }
}
declare const changesById: <T, H extends HookContext<_feathersjs_feathers.Application<any, any>, any>>(cb: (changesById: Record<Id, Change<T>>, context: HookContext) => void | Promise<void>, _options?: Partial<HookChangesByIdOptions>) => (context: H) => Promise<H>;
declare const changesByIdBefore: <H extends HookContext<_feathersjs_feathers.Application<any, any>, any>>(context: H, _options: HookChangesByIdOptions) => Promise<Record<string, unknown> | unknown[]>;
declare const changesByIdAfter: <T, H extends HookContext<_feathersjs_feathers.Application<any, any>, any>>(context: H, itemsBefore: any, cb?: (changesById: Record<Id, Change<T>>, context: H) => void | Promise<void>, _options?: HookChangesByIdOptions) => Promise<Record<Id, Change>>;
declare const getOrFindByIdParams: (context: HookContext, makeParams: ManipulateParams, options?: Pick<HookChangesByIdOptions, "deleteParams">) => Promise<Params>;

interface ViewContext<T = any> {
    item: Change<T>;
    subscription: Subscription;
    subscriptions: Subscription[];
    items: Change<T>[];
    context: HookContext;
}
type ActionOptions<T = any> = {
    subscription: SubscriptionResolved;
    items: Change<T>[];
    context: HookContext;
    view: Record<string, any>;
};
type Action<T = any> = (item: Change<T>, options: ActionOptions<T>) => (Promisable<void>);
type HookTriggerOptions<H extends HookContext = HookContext> = Subscription | Subscription[] | ((context: H) => Promisable<Subscription | Subscription[]>);
type TransformView<T = any> = undefined | ((view: Record<string, any>, viewContext: ViewContext<T>) => Promisable<Record<string, any>>) | Record<string, any>;
type Condition = true | Record<string, any> | ((item: any, context: HookContext) => Promisable<boolean>);
interface Subscription {
    service?: string | string[];
    method?: string | string[];
    conditionsData?: Condition;
    conditionsResult?: Condition;
    conditionsBefore?: Condition;
    conditionsParams?: Condition;
    view?: TransformView;
    params?: ManipulateParams;
    /** @default true */
    isBlocking?: boolean;
    action: Action;
    /** @default false */
    fetchBefore?: boolean;
    [key: string]: any;
    [key: number]: any;
}
interface SubscriptionResolved extends Subscription {
    dataResolved: boolean | Record<string, any>;
    resultResolved: boolean | Record<string, any>;
    beforeResolved: boolean | Record<string, any>;
    paramsResolved: Params;
    identifier: string;
}
declare const trigger: <H extends HookContext<_feathersjs_feathers.Application<any, any>, any>>(options: HookTriggerOptions<H>) => (context: H) => Promise<H>;

export { Action, ActionOptions, Change, ChangesById, ChangesByIdParams, Condition, HookChangesByIdOptions, HookTriggerOptions, ManipulateParams, Subscription, SubscriptionResolved, TransformView, changesById, changesByIdAfter, changesByIdBefore, getOrFindByIdParams, trigger };
